Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPDInelasticFS.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPDInelasticFS.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPDInelasticFS.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPPDInelasticFS.hh,v 1.9 2006/06/29 20:49:09 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 #ifndef G4NeutronHPPDInelasticFS_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPInelasticFS.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPInelasticFS.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPInelasticFS.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPPInelasticFS.hh,v 1.9 2006/06/29 20:49:11 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 #ifndef G4NeutronHPPInelasticFS_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPTInelasticFS.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPTInelasticFS.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPTInelasticFS.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPPTInelasticFS.hh,v 1.9 2006/06/29 20:49:13 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 #ifndef G4NeutronHPPTInelasticFS_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPartial.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPartial.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPartial.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPPartial.hh,v 1.13 2007/06/18 20:56:05 tkoi Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 // 070618 Comment out unused private member leaking by T. Koi
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPhotonDist.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPhotonDist.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPhotonDist.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPPhotonDist.hh,v 1.17 2008/06/26 02:40:23 tkoi Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
  // Hadronic Process: Very Low Energy Neutron X-Sections
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPhotonXSection.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPhotonXSection.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPhotonXSection.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPPhotonXSection.hh,v 1.11 2007/06/06 12:45:13 ahoward Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 #ifndef G4NeutronHPPhotonXSection_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPolynomExpansion.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPolynomExpansion.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPolynomExpansion.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPPolynomExpansion.hh,v 1.11 2007/06/06 12:45:13 ahoward Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 #ifndef G4NeutronHPPolynomExpansion_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPProduct.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPProduct.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPProduct.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPProduct.hh,v 1.12 2007/06/06 12:45:13 ahoward Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 #ifndef G4NeutronHPProduct_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPSCFissionFS.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPSCFissionFS.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPSCFissionFS.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPSCFissionFS.hh,v 1.11 2007/06/06 12:45:13 ahoward Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 #ifndef G4NeutronHPSCFissionFS_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPSimpleEvapSpectrum.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPSimpleEvapSpectrum.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPSimpleEvapSpectrum.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPSimpleEvapSpectrum.hh,v 1.11 2006/06/29 20:49:27 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 #ifndef G4NeutronHPSimpleEvapSpectrum_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPT2AInelasticFS.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPT2AInelasticFS.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPT2AInelasticFS.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPT2AInelasticFS.hh,v 1.9 2006/06/29 20:49:29 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 #ifndef G4NeutronHPT2AInelasticFS_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPTCFissionFS.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPTCFissionFS.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPTCFissionFS.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPTCFissionFS.hh,v 1.11 2007/06/06 12:45:13 ahoward Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 #ifndef G4NeutronHPTCFissionFS_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPTInelasticFS.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPTInelasticFS.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPTInelasticFS.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPTInelasticFS.hh,v 1.9 2006/06/29 20:49:33 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 #ifndef G4NeutronHPTInelasticFS_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPWattSpectrum.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPWattSpectrum.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPWattSpectrum.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPWattSpectrum.hh,v 1.11 2006/06/29 20:49:39 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 #ifndef G4NeutronHPWattSpectrum_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4VNeutronHPEDis.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4VNeutronHPEDis.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4VNeutronHPEDis.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VNeutronHPEDis.hh,v 1.10 2006/06/29 20:50:05 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 #ifndef G4VNeutronHPEDis_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4VNeutronHPEnergyAngular.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4VNeutronHPEnergyAngular.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4VNeutronHPEnergyAngular.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VNeutronHPEnergyAngular.hh,v 1.12 2008/07/21 23:26:29 tkoi Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 // 080718 Add ClearHistories() method by T. Koi
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPInelastic.cc	(revision 1326)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPInelastic.cc	(revision 1337)
@@ -34,5 +34,5 @@
 //
 // $Id: G4NeutronHPInelastic.cc,v 1.24 2008/12/03 22:28:48 tkoi Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 // 070523 bug fix for G4FPE_DEBUG on by A. Howard (and T. Koi)
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPInelasticCompFS.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPInelasticCompFS.cc	(revision 1326)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPInelasticCompFS.cc	(revision 1337)
@@ -695,9 +695,9 @@
    G4double M = hadron->GetDefinition()->GetPDGMass();
    G4double pmag = std::sqrt ((E3+M)*(E3+M)-M*M) ;
-   G4ThreeVector p ( 0 , pmag*sqrt(1-omega3*omega3), pmag*omega3 );
+   G4ThreeVector p ( 0 , pmag*std::sqrt(1-omega3*omega3), pmag*omega3 );
 
    G4double M4 = residual->GetDefinition()->GetPDGMass();
    G4double pmag4 = std::sqrt ((E4+M4)*(E4+M4)-M4*M4) ;
-   G4ThreeVector p4 ( 0 , -pmag4*sqrt(1-omega4*omega4), pmag4*omega4 );
+   G4ThreeVector p4 ( 0 , -pmag4*std::sqrt(1-omega4*omega4), pmag4*omega4 );
 
 // Rotate to orginal target rest flame.
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPNBodyPhaseSpace.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPNBodyPhaseSpace.cc	(revision 1326)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPNBodyPhaseSpace.cc	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPNBodyPhaseSpace.cc,v 1.13 2006/06/29 20:53:11 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 #include "G4NeutronHPNBodyPhaseSpace.hh"
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/History
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/History	(revision 1326)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/History	(revision 1337)
@@ -1,3 +1,3 @@
-$Id: History,v 1.29 2009/12/15 19:20:46 vuzhinsk Exp $
+$Id: History,v 1.31 2010/06/14 16:28:32 gcosmo Exp $
 -------------------------------------------------------------------
 
@@ -15,10 +15,14 @@
      * Please list in reverse chronological order (last date on top)
      ---------------------------------------------------------------
+
+14 Jun 2010 G.Cosmo  (hadr-string-diff-V09-03-01)
+  Added missing virtual destructor to G4DiffractiveHHScatterer.
+   
 15 Dec 2009 V.Uzhinsky  (hadr-string-diff-V09-02-23)
-   Bug was fixed for Kaon + A interactions in G4DiffractiveExcitation.cc
+  Bug was fixed for Kaon + A interactions in G4DiffractiveExcitation.cc
 
 ------------------------------------------------------------
 15 Dec 2009 G.Folger     (hadr-string-diff-V09-02-22)
--  G4FTFModel: In ctor, initialise NumberOfInvolvedNucleon
+  G4FTFModel: In ctor, initialise NumberOfInvolvedNucleon
 
 14 Dec. 2009 V. Uzhinsky (hadr-string-diff-V09-02-21)
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4DiffractiveHHScatterer.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4DiffractiveHHScatterer.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4DiffractiveHHScatterer.hh	(revision 1337)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4DiffractiveHHScatterer.hh,v 1.7 2009/10/06 10:10:36 vuzhinsk Exp $
+// $Id: G4DiffractiveHHScatterer.hh,v 1.8 2010/06/14 16:26:46 gcosmo Exp $
 
 #ifndef G4DiffractiveHHScatterer_h
@@ -52,8 +52,9 @@
 
    G4DiffractiveHHScatterer();
-   
+   virtual ~G4DiffractiveHHScatterer();
+
 //   G4KineticTrackVector * Scatter(const G4KineticTrack & aTrack, const G4KineticTrack & bTrack);
 
-      virtual void CreateStrings() const;
+   virtual void CreateStrings() const;
 /*
                                         (G4VSplitableHadron * aHadron, 
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4DiffractiveSplitableHadron.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4DiffractiveSplitableHadron.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4DiffractiveSplitableHadron.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4DiffractiveSplitableHadron.hh,v 1.5 2009/08/03 13:14:19 vuzhinsk Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFModel.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFModel.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFModel.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FTFModel.hh,v 1.10 2009/10/25 10:50:54 vuzhinsk Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 // Class Description
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFParameters.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFParameters.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFParameters.hh	(revision 1337)
@@ -28,5 +28,5 @@
 //
 // $Id: G4FTFParameters.hh,v 1.7 2009/10/25 10:50:54 vuzhinsk Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 #include "G4Proton.hh"
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFParticipants.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFParticipants.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFParticipants.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FTFParticipants.hh,v 1.6 2009/08/03 13:14:19 vuzhinsk Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4DiffractiveHHScatterer.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4DiffractiveHHScatterer.cc	(revision 1326)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4DiffractiveHHScatterer.cc	(revision 1337)
@@ -36,4 +36,7 @@
   theExcitation(new G4DiffractiveExcitation()),
   theStringFragmentation(new G4LundStringFragmentation())
+{}
+
+G4DiffractiveHHScatterer::~G4DiffractiveHHScatterer()
 {}
 
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4DiffractiveSplitableHadron.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4DiffractiveSplitableHadron.cc	(revision 1326)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4DiffractiveSplitableHadron.cc	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4DiffractiveSplitableHadron.cc,v 1.8 2009/07/31 11:03:00 vuzhinsk Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4FTFModel.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4FTFModel.cc	(revision 1326)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4FTFModel.cc	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FTFModel.cc,v 1.34 2009/12/15 19:14:31 vuzhinsk Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4FTFParameters.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4FTFParameters.cc	(revision 1326)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4FTFParameters.cc	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FTFParameters.cc,v 1.13 2009/12/16 17:51:15 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4FTFParticipants.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4FTFParticipants.cc	(revision 1326)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4FTFParticipants.cc	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FTFParticipants.cc,v 1.16 2009/11/25 09:14:03 vuzhinsk Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 // ------------------------------------------------------------
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/History
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/History	(revision 1326)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/History	(revision 1337)
@@ -1,3 +1,3 @@
-$Id: History,v 1.10 2009/07/17 12:30:45 vuzhinsk Exp $
+$Id: History,v 1.13 2010/06/22 07:29:35 gcosmo Exp $
 -------------------------------------------------------------------
 
@@ -15,9 +15,21 @@
      * Please list in reverse chronological order (last date on top)
      ---------------------------------------------------------------
-17-July-2009 V. Uzhinsky                 (had-hadronization-V09-02-03)
-   Some small optimization are done.
----------------------------------------------------------------------
+
+21-June-2010  V. Uzhinsky               (had-hadronization-V09-03-00)
+--------------------------------------------------------------
+- Lund string fragmentation is improved. The inselfconsistency
+  between LightFragmentationTest and Lund fragmentation is erased.
+  Energy conservation in FTF is recovered.
+
+6-December-2010  V. Uzhinsky,           (had-hadronization-V09-02-04)
+--------------------------------------------------------------
+- Lund string fragm. improved, start fragmentation.
+
+17-July-2009  V. Uzhinsky               (had-hadronization-V09-02-03)
+--------------------------------------------------------------
+- Some small optimization are done.
+
 9-July-2009 V. Uzhinsky                 (had-hadronization-V09-02-02)
----------------------------------------------------------------------
+--------------------------------------------------------------
 - Bug was fixed in G4VLongitudinalStringDecay.cc at calculation of
   formation/creation time, c_light was inserted.
@@ -25,6 +37,6 @@
   G4LundStringFragmentation.cc
 
+22-May-2009   Gunter Folger             (had-hadronization-V09-02-01)
 --------------------------------------------------------------
-22-May-2009   Gunter Folger             (had-hadronization-V09-02-01)
 - remove temporary workaround - fix is now in QGS
 - change pt sampling in G4LundStringFragmentation to avoid near endless
@@ -34,33 +46,32 @@
   to SampleQuarkPt()
 
-
 18-May-2009   Gunter Folger             (had-hadronization-V09-02-00)
 ---------------------------------------------------------------------
 - reset formatting changes by MK with tags hadr-prtn-hadr-V09-02-xx
 - temporary workaround for wrong PDG codes created on wrong input from QGS 
-   when used for e.g. antiproton.
+  when used for e.g. antiproton.
    
 2-May 2007    Gunter Folger             (had-hadronization-V08-02-03)
 ---------------------------------------------------------------------
--  G4ExcitedStringDecay.hh: protect againt divide by 0 when KTsum1.e() 
-    is 0. 
+- G4ExcitedStringDecay.hh: protect againt divide by 0 when KTsum1.e() is 0. 
     
 24-April 2007 Gunter Folger             (had-hadronization-V08-02-02)
 ---------------------------------------------------------------------
--  Seperate FTF and QGS fragmentation dir methods where V.Uzhinsky
-    modified the algorithm for FTF. 
-    
+- Seperate FTF and QGS fragmentation dir methods where V.Uzhinsky
+  modified the algorithm for FTF.
 
-2-March 2007 G.Folger                   (had-hadronization-V08-02-01)
+2-March 2007 Gunter Folger              (had-hadronization-V08-02-01)
 ---------------------------------------------------------------------
 - G4ExcitedStringDecay::EnergyAndMomentumCorrector no longer causes Exception 
-   when no converging. Add more info when failing. Return correct status.
+  when no converging. Add more info when failing. Return correct status.
    
+24-Jan 2007 Gunter Folger               (had-hadronization-V08-02-00)
+--------------------------------------------------------------
+- G4ExcitedStringDecay::EnergyAndMomentumCorrector :
+  Correct bug which did stop correction even if not yet converged;
+  check on convergence must check that scale-1 is close to 0,
+  and not less than 0
 
-24-Jan 2007 GF: 				tag had-hadronization-V08-02-00
-	G4ExcitedStringDecay::EnergyAndMomentumCorrector :
-          Correct bug which did stop correction even if not yet converged;
-          check on convergence must check that scale-1 is close to 0, 
-	  and not less than 0
-26-May 2006 GF: Fix ( finally?) the charge check in G4HadronBuilder.cc
-
+26-May 2006 Gunter Folger
+--------------------------------------------------------------
+- Fix ( finally?) the charge check in G4HadronBuilder.cc
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4ExcitedStringDecay.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4ExcitedStringDecay.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4ExcitedStringDecay.hh	(revision 1337)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4ExcitedStringDecay.hh,v 1.10 2009/10/05 12:52:48 vuzhinsk Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// $Id: G4ExcitedStringDecay.hh,v 1.12 2010/06/21 17:50:48 vuzhinsk Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 #ifndef G4ExcitedStringDecay_h
@@ -72,4 +72,5 @@
 }
 	
+
 inline
 G4KineticTrackVector *G4ExcitedStringDecay::
@@ -78,13 +79,12 @@
   G4KineticTrackVector * theResult = new G4KineticTrackVector;
 
-  G4LorentzVector KTsum;
-  G4LorentzVector KTsecondaries;
+  G4LorentzVector KTsum(0.,0.,0.,0.);
+  G4LorentzVector KTsecondaries(0.,0.,0.,0.);
   G4bool NeedEnergyCorrector=false;
-//G4cout<<"Number of strings "<<theStrings->size()<<G4endl;   // Vova  
+
   for ( unsigned int astring=0; astring < theStrings->size(); astring++)
   {
-//G4cout<<"String# "<<astring<<" 4mom "<<theStrings->operator[](astring)->Get4Momentum()<<G4endl;  // Vova
 	KTsum+= theStrings->operator[](astring)->Get4Momentum();
-//G4cout<<"KTsum "<<KTsum<<G4endl;
+
 	if( !(KTsum.e()<1) && !(KTsum.e()>-1) )
 	{
@@ -108,6 +108,5 @@
 	}
 
-//G4cout<<" prod had "<<generatedKineticTracks->size()<<G4endl; // Vova	
-	G4LorentzVector KTsum1;
+	G4LorentzVector KTsum1(0.,0.,0.,0.);
 	for ( unsigned int aTrack=0; aTrack<generatedKineticTracks->size();aTrack++)
 	{
@@ -115,5 +114,4 @@
 		KTsum1+= (*generatedKineticTracks)[aTrack]->Get4Momentum();
 	}
-
 	KTsecondaries+=KTsum1;
 	
@@ -124,4 +122,5 @@
 	   NeedEnergyCorrector=true;
  	}
+
 //      clean up
 	delete generatedKineticTracks;
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4FragmentingString.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4FragmentingString.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4FragmentingString.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FragmentingString.hh,v 1.4 2007/12/20 15:38:06 vuzhinsk Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4HadronBuilder.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4HadronBuilder.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4HadronBuilder.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HadronBuilder.hh,v 1.5 2009/05/18 09:43:40 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 // -----------------------------------------------------------------------------
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4LundStringFragmentation.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4LundStringFragmentation.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4LundStringFragmentation.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4LundStringFragmentation.hh,v 1.6 2008/04/25 14:20:14 vuzhinsk Exp $
-// GEANT4 tag $Name: geant4-09-03 $ Maxim Komogorov
+// GEANT4 tag $Name: geant4-09-04-beta-01 $ Maxim Komogorov
 //
 // -----------------------------------------------------------------------------
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4QGSMFragmentation.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4QGSMFragmentation.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4QGSMFragmentation.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4QGSMFragmentation.hh,v 1.5 2007/12/20 15:38:07 vuzhinsk Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 // -----------------------------------------------------------------------------
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4VKinkyStringDecay.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4VKinkyStringDecay.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4VKinkyStringDecay.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VKinkyStringDecay.hh,v 1.3 2006/06/29 20:54:53 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //  Maxim Komogorov
 //
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4VLongitudinalStringDecay.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4VLongitudinalStringDecay.hh	(revision 1326)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4VLongitudinalStringDecay.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VLongitudinalStringDecay.hh,v 1.7 2009/05/22 16:35:47 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 // Maxim Komogorov
 //
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4ExcitedStringDecay.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4ExcitedStringDecay.cc	(revision 1326)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4ExcitedStringDecay.cc	(revision 1337)
@@ -76,4 +76,5 @@
       throw G4HadronicException(__FILE__, __LINE__, "G4ExcitedStringDecay received nan mass...");
     }
+
     // Calculate sum hadron 4-momenta and summing hadron mass
     unsigned int cHadron;
@@ -91,7 +92,8 @@
 	}
     }
+
     // Cannot correct a single particle
     if (Output->size() < 2) return FALSE;
-    
+
     if (SumMass > TotalCollisionMass) return FALSE;
     SumMass = SumMom.m2();
@@ -148,11 +150,5 @@
     Beta = TotalCollisionMom.boostVector();
     Output->Boost(Beta);
-/* // Uzhi
-G4cout<<"Number of produced hadrons // correct E and P "<<Output->size()<<G4endl; // Uzhi
-    for(cHadron = 0; cHadron < Output->size(); cHadron++)
-    {
-G4cout<<cHadron<<" "<<Output->operator[](cHadron)->Get4Momentum()<<" "<<Output->operator[](cHadron)->Get4Momentum().mag()<<Output->operator[](cHadron)->GetDefinition()->GetParticleName()<<G4endl;  
-    }
-*/ // Uzhi
+
     return success;
   }
